#*************************************************************
# Progamm:			planeten_temperaturen
# Sinn des Programms: 		Berechnung der Oberflächentemperaturen der Planeten
# Sinn der Einheit  :		Ausgabeeinheit	
# Name dieser Datei:		ausgabe.py
# Versionsnummer:		1
# Wird aufgerufen von:		planeten_temperaturen_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	5
# von:				5			
# Autor: 			Armin Ulrich
# Erster Lauf: 			13.12.2020
# Letzte Änderung: 		11.02.2021
#*************************************************************


#*************************************************************
# Importieren der Klassen zur graphischen Darstellung 
#*************************************************************
import matplotlib.pyplot as plt


class Ausgabe:
  #Konstruktormethode
  def __init__(self):		
    print("Rechnerobjekt erzeugt")
    
  
  #Destruktormethode
  def __del__(self):	
    print("Rechnerobjekt entfernt")  
    
  #Funktion zum Auflösen der Benutzeroberfläche
  def ende(self):
    self.ausgabe_gui.destroy()
        
  def schirm_ausgabe(self,m, nummer, planet,T,T_mittel):
    try:
      print("Schirmausgabe")
      print("m= ",m)
      for i in range(m):
        print(nummer[i], planet[i], T[i])
      return True
    except:
      return False
      
      
  def datei_ausgabe(self,ausgabe_datei, m, nummer, planet,T,T_mittel):
    try:
      print("Dateiausgabe")
      print(ausgabe_datei, m)
      fobj_out = open(ausgabe_datei,"w")
      for i in range(m):
        fobj_out.write(str(nummer[i]))
        fobj_out.write("\t")
        fobj_out.write(planet[i])
        fobj_out.write("\t")
        fobj_out.write(str(T[i]))
        fobj_out.write("\n")
      fobj_out.close() 
      return True 
    except:
      return False
    
  def gui_ausgabe(self,m,  nummer, planet,T,T_mittel):
    try:
      import tkinter
      self.ausgabe_gui = tkinter.Tk()
      print("Guiausgabe",T)
      print(m)
    
      tkinter.Label(self.ausgabe_gui, text='%s'%("Nr."), borderwidth=1 ).grid(row=0,column=0)
      tkinter.Label(self.ausgabe_gui, text='%s'%("Planet"), borderwidth=1 ).grid(row=0,column=1)
      tkinter.Label(self.ausgabe_gui, text='%s'%("Temperatur [K]"), borderwidth=1 ).grid(row=0,column=2)
      for r in range(1,m+1):
        tkinter.Label(self.ausgabe_gui, text='%i'%(nummer[r-1]), borderwidth=1 ).grid(row=r,column=0)
        tkinter.Label(self.ausgabe_gui, text='%s'%(planet[r-1]), borderwidth=1 ).grid(row=r,column=1)
        tkinter.Label(self.ausgabe_gui, text='%f'%(T[r-1]), borderwidth=1 ).grid(row=r,column=2)
      b = tkinter.Button(self.ausgabe_gui, text = "weiter", command = self.ende )
      b.grid(row=m+1, column=0, padx='1', pady='1', sticky='ew')
      self.ausgabe_gui.mainloop()
      return True  
    except:
      return False  
    
  def graphik_ausgabe(self,graphik_entfernung_wähler, graphik_datei, graphik_format,m,nummer,a,T,T_mittel):
    try:
      print("Graphikausgabe")
      print(m)
      a_min=0.0
      a_max=0.0
      T_min=0.0
      T_max=0.0
      for i in range(m):
        if a_min >= a[i]:
          a_min = a[i]
        if a_max <= a[i]:
          a_max = a[i]
        if T_min >= T[i]:
          T_min = T[i]
        if T_max <= T[i]:
          T_max = T[i]
      
      for i in range(m):
        if T_min >= T_mittel[i]:
          T_min = T_mittel[i]
        if T_max <= T_mittel[i]:
          T_max = T_mittel[i]    
      if(graphik_entfernung_wähler):
        plt.plot(a, T_mittel, 'b.',label=r'angegebene Temperatur')
        plt.plot(a,  T, 'r.',label=r'Temperatur berechnet')
      else:
        plt.plot(nummer, T_mittel, 'b.',label=r'angegebene Temperatur')
        plt.plot(nummer,  T, 'r.',label=r'Temperatur berechnet')
    
    
    
      # Achsen-Bereiche manuell festlegen
    
      # Syntax: plt.axis([xmin, xmax, ymin, ymax])
      a_min-=(a_max-a_min)/10.0
      a_max+=(a_max-a_min)/10.0
      T_min-=(T_max-T_min)/10.0
      T_max+=(T_max-T_min)/10.0
      if(graphik_entfernung_wähler):
        plt.axis([a_min, a_max, T_min, T_max])
        plt.xlabel("a [m]")
        plt.title("Planetentemperatur als Funktion der Entfernung von der Sonne" )
      else:
        plt.axis([0, 12, T_min, T_max])
        plt.xlabel("Nummer [-]")
        plt.title("Planetentemperatur" )
    
      plt.ylabel("T [K]")
      plt.legend(loc='upper right', frameon=True)
      # Ein gepunktetes Diagramm-Gitter einblenden:
      plt.grid(True)
      plt.savefig(graphik_datei + "." + graphik_format, format=graphik_format)
     # Diagramm anzeigen:
      plt.show()
      return True
    except:
      return False 
    
    
     
