#*************************************************************
# Progamm:			planeten_temperaturen
# Sinn des Programms: 		Berechnung der Oberflächentemperaturen der Planeten	
# Sinn der Einheit  :		Eingabeeinheit	
# Name dieser Datei:		eingabe.py
# Versionsnummer:		1
# Wird aufgerufen von:		planeten_temperaturen_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	3
# von:				5			
# Autor: 			Armin Ulrich
# Erster Lauf: 			12.12.2020
# Letzte Änderung: 		11.02.2021
#*************************************************************

#*************************************************************
# Importieren der Klassen für Dateiauslesung
#*************************************************************
import os




class Eingabe:
  #Konstruktormethode
  def __init__(self):		
    print("Eingabeobjekt erzeugt")
    

  #Destruktormethode
  def __del__(self):	
    print("Eingabeobjekt entfernt")  

  def ende(self):
    self.main.destroy()    


#*************************************************************
# Funktion zum Öffnen der Steuerdatei und zum Auslesen der
# Steuerdaten
#*************************************************************
  def input_planetendaten(self):
    print("Einlesen der Wärmemengen") 
    self.zeilen_zähler=0
 
#*************************************************************
# Überprüfung ob die Steuerdatei existiert 
#*************************************************************
    if os.path.exists("planeten.dat"):
      fobj_in = open("planeten.dat","r") 
      for zeile in fobj_in:
        self.zeilen_zähler += 1
      fobj_in.close()  
      print("zeilen_zähler=", self.zeilen_zähler)
    
        
      self.nummer = list(range(self.zeilen_zähler-1))
      self.planet = list(range(self.zeilen_zähler-1))
      self.geom_albedo = list(range(self.zeilen_zähler-1))
      self.sphär_albedo = list(range(self.zeilen_zähler-1))
      self.a = list(range(self.zeilen_zähler-1))
      self.T_mittel = list(range(self.zeilen_zähler-1))
      self.zeilen_zähler = 0
#*************************************************************
# Öffnen der Steuerdatei
#*************************************************************
      fobj_in = open("planeten.dat","r") 
      
#*************************************************************
# Einlesen der Steuerdaten zeilenweise
#*************************************************************
      for zeile in fobj_in:
        ausgabe = zeile[:-1]
        #print(ausgabe)
        liste = ausgabe.split("|")
        if self.zeilen_zähler == 0:
          self.kopfzeile = liste
        else:  
          self.nummer[self.zeilen_zähler-1] = int(liste[0])  
          self.planet[self.zeilen_zähler-1] = liste[1]
          self.geom_albedo[self.zeilen_zähler-1] = float(liste[2]) 
          self.sphär_albedo[self.zeilen_zähler-1] = float(liste[3])
          self.a[self.zeilen_zähler-1] = float(liste[4])
          self.T_mittel[self.zeilen_zähler-1] = float(liste[5]) 
        self.zeilen_zähler += 1  
        
      fobj_in.close()
      self.m = self.zeilen_zähler - 1
      print(self.planet)
      print(self.geom_albedo)
      print(self.sphär_albedo)
      print(self.a)
    
    
 
#*************************************************************
# Importieren der Klassen zur graphischen Darstellung 
#*************************************************************

      import tkinter
      self.main = tkinter.Tk()

#*************************************************************
# Anzeigen der Steuerdaten mittels Gitter
#*************************************************************  
      for c in range(6):
        tkinter.Label(self.main, text='%s'%(self.kopfzeile[c]), borderwidth=1 ).grid(row=0,column=c)
      for r in range(1,12):
        tkinter.Label(self.main, text='%s'%(self.nummer[r-1]), borderwidth=1 ).grid(row=r,column=0)
        tkinter.Label(self.main, text='%s'%(self.planet[r-1]), borderwidth=1 ).grid(row=r,column=1)
        tkinter.Label(self.main, text='%s'%(self.geom_albedo[r-1]), borderwidth=2 ).grid(row=r,column=2)
        tkinter.Label(self.main, text='%s'%(self.sphär_albedo[r-1]), borderwidth=2 ).grid(row=r,column=3)
        tkinter.Label(self.main, text='%s'%(self.a[r-1]), borderwidth=2 ).grid(row=r,column=4)
        tkinter.Label(self.main, text='%s'%(self.T_mittel[r-1]), borderwidth=2 ).grid(row=r,column=5)
#*************************************************************
# Button zum Beenden der Anzeige der Wärmemengendaten und 
# zum Start der Berechnungen
#*************************************************************       
      b = tkinter.Button(self.main, text = "weiter", command = self.ende )
      b.grid(row=12, column=0, padx='1', pady='1', sticky='ew') 
             
      
      self.main.mainloop()
      
      return True
    else:
      print("Datei ist NICHT vorhanden")
      return False   
