#*************************************************************
# Progamm:			planeten_temperaturen
# Sinn des Programms: 		Berechnung der Oberflächentemperaturen der Planeten				
# Sinn der Einheit  :		Hauptprogramm	
# Name dieser Datei:		planeten_temperaturen_haupt.py
# Wird aufgerufen von:		-
# Ruft auf:			steuer.py, isa_lese.py, rechner.py, ausgabe.py
# Nummer im Programmpaket:	1
# von:				4			
# Autor: 			Armin Ulrich
# Erster Lauf: 			04.12.2020
# Letzte Änderung: 		11.02.2021
#*************************************************************


#*************************************************************
# Importieren der Klassen zur Zeitdokumentation
#*************************************************************
import time
import datetime
	
#*************************************************************
# Importieren der Klassen
#*************************************************************

from steuer import Steuer
from eingabe import Eingabe
from rechner import Rechner
from ausgabe import Ausgabe


#*************************************************************
# Belegung der Klassen
#*************************************************************
steuer = Steuer()
eingabe = Eingabe()
rechner = Rechner()
ausgabe = Ausgabe()

#*************************************************************
# Berechnung der Startzeit des Programmes mit:
# a) datetime
# b) time
# und Konvertieren der Startzeit zu einem String "datum_zeit"
#*************************************************************
dt_start = datetime.datetime.now()
lt_start = time.localtime()
jahr, monat, tag, stunde, minute, sekunde  = lt_start[0:6]
datum_zeit = "Datum: " +str(tag)+"."+str(monat)+"."+str(jahr)+"\n"+"Zeit: "+str(stunde)+":"+str(minute)+":"+str(sekunde)


#*************************************************************
# Ausgabe an
#*************************************************************
print("Planeten-Temperaturen")



  
#*************************************************************
# Öffnen der Logdatei
#*************************************************************
fobj_log = open("planeten_temperaturen.log","w")
#*************************************************************
# Schreiben von Datum und Zeit des Programmstarts 
# in die Logdatei 
#*************************************************************
print("Anfang: "+ "\n" + datum_zeit)
fobj_log.write("Anfang: "+ "\n" + datum_zeit)
fobj_log.write("\n")

if(steuer.input()):
  print("Steuerdatei existiert")
  fobj_log.write( "Steuerdatei existiert\n")
  if eingabe.input_planetendaten():
    print("Eingabedatei existiert.")
    fobj_log.write( "Eingabedatei existiert\n")
    if rechner.temperatur_rechner(steuer.T_Sonne, steuer.R_Sonne,eingabe.m, eingabe.nummer, eingabe.planet, eingabe.geom_albedo, eingabe.sphär_albedo, eingabe.a):
      print("Rechnung durchgeführt.")
      fobj_log.write( "Rechnung durchgeführt\n")
      if(steuer.schirm_ausgabe_wähler):
        if ausgabe.schirm_ausgabe(eingabe.m, eingabe.nummer, eingabe.planet, rechner.T, eingabe.T_mittel):
          print("Schirmausgabe o.k.")
          fobj_log.write( "Schirmausgabe o.k.\n")
        else:
          print("Fehler in Schirmausgabe!")
          fobj_log.write( "Fehler in Schirmausgabe!\n")
      if(steuer.datei_ausgabe_wähler):      
        if ausgabe.datei_ausgabe(steuer.ausgabe_datei, eingabe.m, eingabe.nummer, eingabe.planet, rechner.T, eingabe.T_mittel):
          print("Dateiausgabe o.k.")
          fobj_log.write( "Dateiausgabe o.k.\n")
        else:
          print("Fehler in Dateiausgabe!")
          fobj_log.write( "Fehler in Dateiausgabe!\n")
      if(steuer.gui_ausgabe_wähler):        
        if ausgabe.gui_ausgabe(eingabe.m, eingabe.nummer, eingabe.planet, rechner.T, eingabe.T_mittel):
          print("GUI-Ausgabe o.k.")
          fobj_log.write( "GUI-Ausgabe o.k.\n")
        else:
          print("Fehler in GUI-Ausgabe")
          fobj_log.write( "Fehler in GUI-Ausgabe\n")
      if(steuer.graphik_ausgabe_wähler):      
        if ausgabe.graphik_ausgabe(steuer.graphik_entfernung_wähler, steuer.graphik_datei, steuer.graphik_format,eingabe.m,eingabe.nummer, eingabe.a,rechner.T, eingabe.T_mittel):
          print("Graphikausgabe o.k.")
          fobj_log.write( "Graphikausgabe o.k.\n")
        else:
          print("Fehler in Graphikausgabe")
          fobj_log.write( "Fehler in Graphikausgabe\n") 
          
    else:
      print("Fehler in Rechnung")
      fobj_log.write( "Fehler in Rechnung\n")
        
  else:
    print("Eingabedatei existiert nicht")
    fobj_log.write( "Eingabedatei existiert nicht\n") 
    
else:
  print("Steuerdatei existiert nicht")
  fobj_log.write( "Steuerdatei existiert nicht\n")


#*************************************************************
# Berechnung der Endzeit des Programmes mit:
# a) datetime
# b) time
# und Konvertieren der Endzeit zu einem String "datum_zeit"
#*************************************************************
lt_end = time.localtime()
jahr, monat, tag, stunde, minute, sekunde  = lt_end[0:6]
datum_zeit = "Datum: "+str(tag)+"."+str(monat)+"."+str(jahr)+"\n"+"Zeit: "+str(stunde)+":"+str(minute)+":"+str(sekunde)
dt_end = datetime.datetime.now()

#*************************************************************
# Berechnung der Rechendauer mit dem Zeitdifferenzoperator 
# des Moduls datetime
#*************************************************************
dauer = dt_end - dt_start

#*************************************************************
# Schreiben von Datum und Zeit des Programmendes und der 
# Rechendauer in die Logdatei 
#*************************************************************
fobj_log.write("Ende: "+ "\n" +datum_zeit + "\n")
fobj_log.write("Rechendauer: "+ "\n" + str(dauer))
print("Ende: "+ "\n" +datum_zeit)
print("Rechendauer: "+ "\n" + str(dauer))
#*************************************************************
# Schließen der Logdatei
#*************************************************************
fobj_log.close()

#*************************************************************
#Programmende
#*************************************************************


