#*************************************************************
# Progamm:			planeten_temperaturen
# Sinn des Programms: 		Berechnung der Oberflächentemperaturen der Planeten
# Sinn der Einheit  :		Steuereinheit	
# Name dieser Datei:		steuer.py
# Versionsnummer:		1
# Wird aufgerufen von:		planeten_temperaturen.py
# Ruft auf:			-
# Nummer im Programmpaket:	2
# von:				5		
# Autor: 			Armin Ulrich
# Erster Lauf: 			11.12.2020
# Letzte Änderung: 		11.02.2021
#*************************************************************

#*************************************************************
# Importieren der Klassen für Dateiauslesung
#*************************************************************
import os


class Steuer:
  #Konstruktormethode
  def __init__(self):		
    print("Steuerobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Steuerobjekt entfernt")  

  def ende(self):
    self.main.destroy()


#*************************************************************
# Funktion zum Öffnen der Steuerdatei und zum Auslesen der
# Steuerdaten
#*************************************************************
  def input(self):
#*************************************************************
# Importieren der Klassen zur graphischen Darstellung 
#*************************************************************
    import tkinter
    self.main = tkinter.Tk()

    print("Einlesen der Steuerdaten") 
    zeilen_zaehler=0

#*************************************************************
# Überprüfung ob die Steuerdatei existiert 
#*************************************************************
    if os.path.exists("steuer.txt"):
      print("Datei ist vorhanden")

#*************************************************************
# Öffnen der Steuerdatei
#*************************************************************
      fobj_in = open("steuer.txt","r") 

#*************************************************************
# Einlesen der Steuerdaten zeilenweise
#*************************************************************
      for zeile in fobj_in:
       
        if zeilen_zaehler == 0:
          ausgabe = zeile[:-1]
          print(ausgabe)
        if zeilen_zaehler == 1:
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
          self.T_Sonne = float(zeile[:-1])
          ausgabe = self.T_Sonne
          print(ausgabe)
        if zeilen_zaehler == 2:
          ausgabe = zeile[:-1]
          print(ausgabe)
        if zeilen_zaehler == 3:
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
          self.R_Sonne = float(zeile[:-1])
          ausgabe = self.R_Sonne
          print(ausgabe)  
        if zeilen_zaehler == 4:
          ausgabe = zeile[:-1]
          print(ausgabe)
        if zeilen_zaehler == 5:
          self.ausgabe_datei = zeile[:-1]
          ausgabe = self.ausgabe_datei
          print(ausgabe)  
        if zeilen_zaehler == 6:
          ausgabe = zeile[:-1]
          print(ausgabe)
        if zeilen_zaehler == 7:
          self.graphik_datei = zeile[:-1]
          ausgabe = self.graphik_datei
          print(ausgabe) 
        if zeilen_zaehler == 8:
          ausgabe = zeile[:-1]
          print(ausgabe)
        if zeilen_zaehler == 9:
          self.schirm_ausgabe_wähler = self.bool_function(zeile[:-1])
          ausgabe = self.schirm_ausgabe_wähler
          print(ausgabe)  
        if zeilen_zaehler == 10:
          ausgabe = zeile[:-1]
          print(ausgabe)
        if zeilen_zaehler == 11:
          self.datei_ausgabe_wähler = self.bool_function(zeile[:-1])
          ausgabe = self.datei_ausgabe_wähler
          print(ausgabe) 
        if zeilen_zaehler == 12:
          ausgabe = zeile[:-1]
          print(ausgabe)
        if zeilen_zaehler == 13:
          self.gui_ausgabe_wähler = self.bool_function(zeile[:-1])
          ausgabe = self.gui_ausgabe_wähler
          print(ausgabe)  
        if zeilen_zaehler == 14:
          ausgabe = zeile[:-1]
          print(ausgabe)
        if zeilen_zaehler == 15:
          self.graphik_ausgabe_wähler = self.bool_function(zeile[:-1])
          ausgabe = self.graphik_ausgabe_wähler
          print(ausgabe) 
        if zeilen_zaehler == 16:
          ausgabe = zeile[:-1]
          print(ausgabe)
        if zeilen_zaehler == 17:
          self.graphik_format = zeile[:-1]
          ausgabe = self.graphik_format
          print(ausgabe) 
        if zeilen_zaehler == 18:
          ausgabe = zeile[:-1]
          print(ausgabe)
        if zeilen_zaehler == 19:
          self.graphik_entfernung_wähler = self.bool_function(zeile[:-1])
          ausgabe = self.graphik_entfernung_wähler
          print(ausgabe)  
#*************************************************************
# Letzte Größe: Angenommener Fehler in Delta_T
#*************************************************************          
        
#*************************************************************
# Anzeigen der Steuerdaten mittels Label
#*************************************************************        
        lb = tkinter.Label(self.main, text = ausgabe)
        
        if zeilen_zaehler % 2 == 0:
          lb.grid(row=int(zeilen_zaehler/2), column=0, padx='1', pady='1', sticky='ew')
          #lb["font"] = "Arial 6 bold"
        else:
          lb.grid(row=int((zeilen_zaehler-1)/2), column=1, padx='1', pady='1', sticky='ew') 
        lb["font"] = "Arial 10"
        #lb["height"] = 1
        #lb["width"] = 40
        #lb["borderwidth"] = 2
        #lb["relief"] = "ridge"
        lb["bg"] = "#FFFFFF"
        lb["fg"] = "#000000"
        
        if zeilen_zaehler % 2 == 0:
          lb["anchor"] = "w"
        else:
          lb["anchor"] = "e"
        #lb.pack() 
        zeilen_zaehler=zeilen_zaehler+1
      fobj_in.close()
      
#*************************************************************
# Button zum Beenden der Anzeige der Steuerdaten und 
# zum Start der Berechnungen
#*************************************************************
      b = tkinter.Button(self.main, text = "weiter", command = self.ende)
      b.grid(row=int(zeilen_zaehler/2), column=0, padx='1', pady='1', sticky='ew')
      
      
      #Endlosschleife
      self.main.mainloop()
      
      return True
    else:
      print("Datei ist NICHT vorhanden")
      return False
 
  def bool_function(self,arg):
    s_true = set(["True", "true", "T", "t", "1" ])
    s_false = set(["False", "false", "F", "f", "0" ])
    if arg in s_true:
      return True
    elif arg in s_false:
      return False
    else:     
      return False 

